# r10k puppet module

[![Build Status](https://travis-ci.org/cirrax/puppet-r10k.svg?branch=master)](https://travis-ci.org/cirrax/puppet-r10k)
[![Puppet Forge](https://img.shields.io/puppetforge/v/cirrax/r10k.svg?style=flat-square)](https://forge.puppetlabs.com/cirrax/r10k)
[![Puppet Forge](https://img.shields.io/puppetforge/dt/cirrax/r10k.svg?style=flat-square)](https://forge.puppet.com/cirrax/r10k)
[![Puppet Forge](https://img.shields.io/puppetforge/e/cirrax/r10k.svg?style=flat-square)](https://forge.puppet.com/cirrax/r10k)
[![Puppet Forge](https://img.shields.io/puppetforge/f/cirrax/r10k.svg?style=flat-square)](https://forge.puppet.com/cirrax/r10k)

#### Table of Contents

1. [Overview](#overview)
1. [Usage](#usage)
1. [Reference](#reference)
1. [Contribuiting](#contributing)


## Overview

This module is used to configure r10k.

## Usage

To use r10k you invoke the main r10k class on your
puppet server.

~~~
class{'r10k':}
~~~

If you want to use the gitolite hook to automatically
update the puppet environments on new commits, invoke 
the r10k::gitolite_hooks class on the git server and make 
the authorize the gitolite ssh key to run the r10k scripts.

~~~
class{'r10k::gitolite_hooks':}
~~~

## Reference
Find documentation about possible parameters on top of each manifest or have a look at REFERENCE.md.

### classes

#### r10k
The main class to use on the puppet server

#### r10k::authorized_key
Define an authorized key on the server

#### r10k::user
This class creates an r10k user with ssh keys etc.

#### r10k::gitolite_hooks
Class to install hooks on a gitolite server
to trigger r10k updates.

Adaptions to other git servers are very welcome.

#### r10k::ssh_key
Generate an SSH authentication key for r10k to
fetch git repositories.

### defined types

none

## Remarks
if you install r10k with the gem provider (default for RedHat family) 
you need to ensure that you have ruby-devel (or ruby-dev) package installed.

## Contributing

Please report bugs and feature request using GitHub issue tracker.

For pull requests, it is very much appreciated to check your Puppet manifest with puppet-lint
and the available spec tests  in order to follow the recommended Puppet style guidelines
from the Puppet Labs style guide.

### Authors

This module is mainly written by [Cirrax GmbH](https://cirrax.com).

See the [list of contributors](https://github.com/cirrax/puppet-r10k/graphs/contributors)
for a list of all contributors.
